"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeStyledComponent = exports.updateComponentThemeMap = void 0;

var _react = _interopRequireDefault(require("react"));

var _hooks = require("../hooks/");

var _lodash = _interopRequireDefault(require("lodash.get"));

var _reactNative = require("react-native");

var _core = require("../core");

var _getStyledComponentAndObjects = require("./getStyledComponentAndObjects");

var _theme = require("../theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

//@ts-ignore
// eslint-disable-next-line dot-notation
window['StyleSheet'] = _reactNative.StyleSheet;

// window['logger'] = {};
// console.batchTime = (key) => {
//   const keyValue = window['logger'][key];
//   if (keyValue) {
//     // keyValue.totalTime = keyValue.totalTime + (Date.now() - keyValue.startTime);
//     keyValue.startTime = window.performance.now();
//   } else {
//     window['logger'][key] = {
//       startTime: window.performance.now(),
//       totalTime: 0,
//     };
//   }
// };
// console.batchTimeEnd = (key) => {
//   const keyValue = window['logger'][key];
//   if (keyValue) {
//     keyValue.totalTime =
//       keyValue.totalTime + (window.performance.now() - keyValue.startTime);
//     // console.log(
//     //   "useStyledSystemPropsResolver 2222",
//     //   keyValue,
//     //   window.performance.now()
//     // );
//   }
// };
const resolveForInternalPseudoProps = (name, key, styledObj, colorMode, mergeDefaultProps = true) => {
  // if (name !== 'Button') {
  //   return;
  // }
  for (const property in styledObj.internalPseudoProps) {
    if (_core.PSEUDO_PROP_COMPONENT_MAP[property]) {
      // if (key === 'Button.sm') {
      //   console.log(
      //     mergeDefaultProps,
      //     key,
      //     PSEUDO_PROP_COMPONENT_MAP[property],
      //     '******'
      //   );
      // }
      updateComponentThemeMapForColorMode(_core.PSEUDO_PROP_COMPONENT_MAP[property], "".concat(key, ".").concat(_core.PSEUDO_PROP_COMPONENT_MAP[property]), styledObj.internalPseudoProps[property], colorMode, false, mergeDefaultProps);
    } else {
      // const themeProps = getThemeProps(name, colorMode, {
      //   [pseudoPropStateMap[property]]: true,
      // });
      // if (property === '_hover') {
      //   console.log(
      //     // name,
      //     // property,
      //     // pseudoPropStateMap[property],
      //     themeProps,
      //     {
      //       ...themeProps.styleFromProps,
      //       ...styledObj.internalPseudoProps[property],
      //     },
      //     'theme props '
      //   );
      // }
      const styledObjNestedProp = (0, _getStyledComponentAndObjects.getStyledObject)(name, {}, colorMode, styledObj.internalPseudoProps[property]);
      const componentMapPath = key;
      const componentObj = (0, _core.get)(componentMapPath);

      if (componentObj) {
        // const stateKey = key.slice(componentMapPath.length + 1);
        if (_core.pseudoPropStateMap[property]) {
          const stateKey = property;

          if (componentObj[stateKey]) {
            if (!componentObj[stateKey][colorMode]) {
              componentObj[stateKey][colorMode] = [];
            }

            componentObj[stateKey][colorMode].push(styledObjNestedProp);
          } else {
            componentObj[stateKey] = {
              [colorMode]: [styledObjNestedProp]
            };
          }
        } else {
          // console.log(
          //   'hello here &&&*',
          //   styledObj.internalPseudoProps[property]
          // );
          componentObj[colorMode][0].unResolvedProps = { ...componentObj[colorMode][0].unResolvedProps,
            [property]: styledObj.internalPseudoProps[property]
          };
        }
      }
    }
  }
};

const updateComponentThemeMapForColorMode = (name, key, inputProps, colorMode = 'light', resolveForStatePseudoProps = false, mergeDefaultProps = true) => {
  let componentTheme = (0, _lodash.default)(_theme.theme, "components.".concat(name), {}); // resolve for variant

  if (resolveForStatePseudoProps) {
    componentTheme = {};
  }

  const styledObj = (0, _getStyledComponentAndObjects.getStyledObject)(name, componentTheme, colorMode, { ...inputProps,
    extraProp: key
  }, mergeDefaultProps);
  (0, _core.set)(key, styledObj, colorMode);
  resolveForInternalPseudoProps(name, key, styledObj, colorMode, mergeDefaultProps);
  return styledObj;
};

const updateComponentThemeMap = (name, inputProps) => {
  updateComponentThemeMapForColorMode(name, name, inputProps, 'light');
  updateComponentThemeMapForColorMode(name, name, inputProps, 'dark'); // resolve for all variants

  const componentTheme = (0, _lodash.default)(_theme.theme, "components.".concat(name), {}); // resolve for colors only for button

  if (_core.COLOR_SCHEME_MAP[name]) {
    for (const color in _theme.theme.colors) {
      if (!['white', 'black', 'lightText', 'darkText', 'contrastThreshold'].includes(color)) {
        updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(color), {
          colorScheme: color
        }, 'light' // true
        );
        updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(color), {
          colorScheme: color
        }, 'dark' // true
        );

        for (const variant in componentTheme.variants) {
          updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(color, ".").concat(variant), {
            variant: variant,
            colorScheme: color
          }, 'light' // true
          );
          updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(color, ".").concat(variant), {
            variant: variant,
            colorScheme: color
          }, 'dark' // true
          );
        }
      } // console.log(color, 'hello &&&&&');

    }
  } else {
    for (const variant in componentTheme.variants) {
      updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(variant), {
        variant: variant
      }, 'light' // true
      );
      updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(variant), {
        variant: variant
      }, 'dark');
    }
  } // resolve for all sizes


  for (const size in componentTheme.sizes) {
    updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(size), {
      size: size
    }, 'light', false, false);
    updateComponentThemeMapForColorMode(name, "".concat(name, ".").concat(size), {
      size: size
    }, 'dark', false, false);
  } // resolve for all variants and sizes
  // for (const variant in componentTheme.variants) {
  //   for (const size in componentTheme.sizes) {
  //     updateComponentThemeMapForColorMode(
  //       name,
  //       `${name}.${variant}.${size}`,
  //       { size: size, variant: variant },
  //       'light'
  //     );
  //     updateComponentThemeMapForColorMode(
  //       name,
  //       `${name}.${variant}.${size}`,
  //       { size: size, variant: variant },
  //       'dark'
  //     );
  //   }
  // }

};

exports.updateComponentThemeMap = updateComponentThemeMap;

const makeStyledComponent = Comp => // componentName: keyof ITheme['components']
{
  //TODO: component theme
  // return <> </>;
  // const globalLightStyle = getStyledComponent(componentName, 'light');
  // const globalDarkStyle = getStyledComponent(componentName, 'dark');
  // console.log(StyleSheet.flatten(globalLightStyle.style), 'hello style');
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  return /*#__PURE__*/_react.default.forwardRef(({
    debug,
    ...props
  }, ref) => {
    // console.log(props, 'hello props **********');
    const [style, restProps] = (0, _hooks.useStyledSystemPropsResolver)(props); // console.log(props, 'props here');
    // if (process.env.NODE_ENV === "development" && debug) {
    //   /* eslint-disable-next-line */
    //   console.log(
    //     `%cstyleSystem`,
    //     "background: #4b5563; color: #d97706; font-weight: 700; padding: 2px 8px;"
    //   );
    //   /* eslint-disable-next-line */
    //   console.log("%c props: ", "color: #4ade80; font-weight: 700;", props);
    //   /* eslint-disable-next-line */
    //   console.log("%c style: ", "color: #22d3ee; font-weight: 700;", style);
    //   /* eslint-disable-next-line */
    //   console.log(
    //     "%c restProps: ",
    //     "color: #22d3ee; font-weight: 700;",
    //     restProps
    //   );
    // }
    // console.log("box props", props);
    // const safeAreaProps = useSafeArea(props);
    // console.timeEnd("useSafeArea");
    // check dark / light mode
    // based on color mode pass style
    // const { colorMode } = useColorMode();
    // let componentStyle = {};
    // if (colorMode === 'light') {
    //   componentStyle = globalLightStyle;
    // } else {
    //   componentStyle = globalDarkStyle;
    // }

    return /*#__PURE__*/_react.default.createElement(Comp, _extends({}, restProps, {
      style: style,
      ref: ref
    }), props.children);
  });
}; // console.time('resolveTheme>>>>');


exports.makeStyledComponent = makeStyledComponent;

for (const key in _theme.theme.components) {
  updateComponentThemeMap(key);
} // updateComponentThemeMap('Text');
// console.timeEnd('resolveTheme>>>>');
// for (const key in theme.components) {
// }
// updateComponentThemeMap('Icon');
//# sourceMappingURL=styled.js.map